if (!String.prototype.endsWith) {
    String.prototype.endsWith = function (search, this_len) {
        if (this_len === undefined || this_len > this.length) {
            this_len = this.length;
        }
        return this.substring(this_len - search.length, this_len) === search;
    };
}
if (!String.prototype.startsWith) {
    String.prototype.startsWith = function (search, pos) {
        return this.substr(!pos || pos < 0 ? 0 : +pos, search.length) === search;
    };
}


function wcpaInitMap() {
    var componentForm = {
        street_number: 'short_name',
        route: 'long_name',
        locality: 'long_name',
        administrative_area_level_1: 'short_name',
        country: 'long_name',
        postal_code: 'short_name'
    };
    jQuery('.wcpa_type_placeselector').each(function () {
        var input = jQuery(this).find('.wcpa_google_place').get(0);
        var $that = jQuery(this);
        var autocomplete = new google.maps.places.Autocomplete(input);

        if(wcpa_global_vars.google_map_countries!='' && Array.isArray(wcpa_global_vars.google_map_countries)){
            autocomplete.setComponentRestrictions({'country': wcpa_global_vars.google_map_countries});
        }

        var geocoder = new google.maps.Geocoder();
        autocomplete.addListener('place_changed', function () {
            var place = autocomplete.getPlace();

            for (var component in componentForm) {
                jQuery('.' + component, $that).val('');
                jQuery('.' + component, $that).removeAttr('disabled', 'disabled');
            }
            for (var i = 0; i < place.address_components.length; i++) {
                var addressType = place.address_components[i].types[0];
                if (componentForm[addressType]) {
                    var val = place.address_components[i][componentForm[addressType]];
                    jQuery('.' + addressType, $that).val(val);

                }
            }
            if (place.geometry) {
                jQuery('.wcpa_lat', $that).val(place.geometry.location.lat());
                jQuery('.wcpa_lng', $that).val(place.geometry.location.lng());
            }
        });
        if ($that.find('.wcpa_map').length) {
            var map = new google.maps.Map($that.find('.wcpa_map').get(0), {
                center: {lat: 0, lng: 0},
                zoom: 15
            });
            var marker;
            autocomplete.bindTo('bounds', map);

            var marker = new google.maps.Marker({
                map: map,
                draggable: true,
                anchorPoint: new google.maps.Point(0, -29)
            });
            jQuery.post("https://www.googleapis.com/geolocation/v1/geolocate?key=" + wcpa_global_vars.google_map_api, function (success) {
                map.setCenter(success.location);
                marker.setVisible(false);
                marker.setPosition(success.location);
                marker.setVisible(true);
            })
            google.maps.event.addListener(marker, 'dragend', function () {
                jQuery('.wcpa_lat', $that).val(marker.getPosition().lat());
                jQuery('.wcpa_lng', $that).val(marker.getPosition().lng());
                geocoder.geocode({
                    latLng: marker.getPosition()
                }, function (responses) {
                    for (var component in componentForm) {
                        jQuery('.' + component, $that).val('');
                        jQuery('.' + component, $that).removeAttr('disabled', 'disabled');
                    }
                    if (responses && responses.length > 0) {
                        jQuery('.wcpa_google_place', $that).val(responses[0].formatted_address);
                        jQuery.wcpaIterate();
                        for (var i = 0; i < responses[0].address_components.length; i++) {
                            var addressType = responses[0].address_components[i].types[0];
                            if (componentForm[addressType]) {
                                var val = responses[0].address_components[i][componentForm[addressType]];
                                jQuery('.' + addressType, $that).val(val);

                            }
                        }
                    }
                });
            });
            autocomplete.addListener('place_changed', function () {
                marker.setVisible(false);
                var place = autocomplete.getPlace();
                if (!place.geometry) {
                    // User entered the name of a Place that was not suggested and
                    // pressed the Enter key, or the Place Details request failed.
                    window.alert("No details available for input: '" + place.name + "'");
                    return;
                }
                // If the place has a geometry, then present it on a map.
                if (place.geometry.viewport) {
                    map.fitBounds(place.geometry.viewport);
                } else {
                    map.setCenter(place.geometry.location);
                    map.setZoom(17);  // Why 17? Because it looks good.
                }
                marker.setPosition(place.geometry.location);
                marker.setVisible(true);

            });
        }

    })
}

(function ($) {
    // add class wcpa_has_price for fiedsl which have price
    // on change or on keyup , update price value for that field and also recaclulate total
    //this will work for text,number,
    $(document).on("click", ".single_add_to_cart_button", function (e) {
        if ($(this).is('.wcpa_disable_cart')) {
            alert(wcpa_global_vars.strings.ajax_file_upload);
            e.preventDefault();
        }
    });

    function wcpa_show_val_error($field, $mesg) {
        if ($field.next('.wcpa_error_msg').length) {
            $field.next('.wcpa_error_msg').html('<p>' + $mesg + '</p>');
        } else {
            $('<div class="wcpa_error_msg"><p>' + $mesg + '</p></div>').insertAfter($field);
        }

    }

    function wcpa_remove_val_error($field) {
        if ($field.next('.wcpa_error_msg').length) {
            $field.next('.wcpa_error_msg').remove();
        }
    }

    /*Image preview start */
    function wcpa_product_image_update($form, $ele) {

        if ($ele == false) { // reset image only if it has updated by wcpa
            if ($form.data('wcpa_product_image') == true) {
                $form.wc_variations_image_update(false);
                $form.data('wcpa_product_image', false);
                $form.find('.variations select').trigger('change');
            }
            return;
        }
        var image = $ele.data('image');
        var object1 = {
            image: image
        };

        $.extend(object1, {image: image});
        $form.wc_variations_image_update(object1);
        $form.data('wcpa_product_image', true);

         // porto theme support
          var $product       = $form.closest( '.product, .product-col' );
          var $image_slider  = $product.find('.product-image-slider');
          var $thumbs_slider = $product.find('.product-thumbs-slider');
            if ($image_slider.length) {
                $image_slider.trigger('to.owl.carousel', [0, 100, true]);
            }
            if ($thumbs_slider.length) {
                $thumbs_slider.trigger('to.owl.carousel', [0, 100, true]);
            }

          var $shop_single_image     = $product.find( 'div.product-images .woocommerce-main-image' ).length ? $product.find( 'div.product-images .woocommerce-main-image' ) : $('.single-product div.product-images .woocommerce-main-image');
          if($shop_single_image && $shop_single_image.length){
              $shop_single_image.attr( 'src', image.src );
              $shop_single_image.attr( 'srcset', '' );
              $shop_single_image.attr( 'alt', image.title );
              $shop_single_image.attr( 'href',  image.full_src );
            //  $shop_thumb_image.attr( 'src', image.gallery_thumbnail_src );
          
          }
    }

    // $.fn.wcpa_product_image_update = function(image) {
    //     $form  = this;
    //     $product = $form.closest('.product'),
    //         $product_gallery = $product.find('.images'),
    //         $gallery_nav = $product.find('.flex-control-nav'),
    //         $gallery_img = $gallery_nav.find('li:eq(0) img'),
    //         $product_img_wrap = $product_gallery.find('.woocommerce-product-gallery__image, .woocommerce-product-gallery__image--placeholder').eq(0),
    //         $product_img = $product_img_wrap.find('.wp-post-image'),
    //         $product_link = $product_img_wrap.find('a').eq(0);
    //
    //     if (image && image.src) {
    //         // See if the gallery has an image with the same original src as the image we want to switch to.
    //         var galleryHasImage = $gallery_nav.find('li img[data-o_src="' + image.src + '"]').length > 0;
    //
    //         // If the gallery has the image, reset the images. We'll scroll to the correct one.
    //         if (galleryHasImage) {
    //             $form.wcpa_product_image_reset();
    //         }
    //
    //         // See if gallery has a matching image we can slide to.
    //         var slideToImage = $gallery_nav.find('li img[src="' + variation.image.gallery_thumbnail_src + '"]');
    //
    //         if (slideToImage.length > 0) {
    //             slideToImage.trigger('click');
    //             $form.attr('current-image', variation.image_id);
    //             window.setTimeout(function () {
    //                 $(window).trigger('resize');
    //                 $product_gallery.trigger('woocommerce_gallery_init_zoom');
    //             }, 20);
    //             return;
    //         }
    //
    //         $product_img.wcpa_product_image_sett_attr('src', image.src);
    //         // $product_img.wcpa_product_image_sett_attr('height', variation.image.src_h);
    //         // $product_img.wcpa_product_image_sett_attr('width', variation.image.src_w);
    //         // $product_img.wcpa_product_image_sett_attr('srcset', image.srcset);
    //         // $product_img.wcpa_product_image_sett_attr('sizes', variation.image.sizes);
    //         $product_img.wcpa_product_image_sett_attr('title', image.title);
    //         // $product_img.wcpa_product_image_sett_attr('data-caption', variation.image.caption);
    //         $product_img.wcpa_product_image_sett_attr('alt', image.alt);
    //         $product_img.wcpa_product_image_sett_attr('data-src', image.src);
    //         // $product_img.wcpa_product_image_sett_attr('data-large_image', variation.image.full_src);
    //         // $product_img.wcpa_product_image_sett_attr('data-large_image_width', variation.image.full_src_w);
    //         // $product_img.wcpa_product_image_sett_attr('data-large_image_height', variation.image.full_src_h);
    //         $product_img_wrap.wcpa_product_image_sett_attr('data-thumb', image.src);
    //         $gallery_img.wcpa_product_image_sett_attr('src', image.src);
    //         $product_link.wcpa_product_image_sett_attr('href', image.src);
    //     } else {
    //         $form.gallery_image_reset();
    //     }
    //
    //     window.setTimeout(function () {
    //         $(window).trigger('resize');
    //         $form.wc_maybe_trigger_slide_position_reset(variation);
    //         $product_gallery.trigger('woocommerce_gallery_init_zoom');
    //     }, 20);
    // };
    //
    // $.fn.wcpa_gallery_image_reset = function () {
    //     $form  = this;
    //     $product = $form.closest('.product'),
    //         $product_gallery = $product.find('.images'),
    //         $gallery_nav = $product.find('.flex-control-nav'),
    //         $gallery_img = $gallery_nav.find('li:eq(0) img'),
    //         $product_img_wrap = $product_gallery.find('.woocommerce-product-gallery__image, .woocommerce-product-gallery__image--placeholder').eq(0),
    //         $product_img = $product_img_wrap.find('.wp-post-image'),
    //         $product_link = $product_img_wrap.find('a').eq(0);
    //
    //     $product_img.wc_reset_variation_attr('src');
    //     $product_img.wc_reset_variation_attr('width');
    //     $product_img.wc_reset_variation_attr('height');
    //     $product_img.wc_reset_variation_attr('srcset');
    //     $product_img.wc_reset_variation_attr('sizes');
    //     $product_img.wc_reset_variation_attr('title');
    //     $product_img.wc_reset_variation_attr('data-caption');
    //     $product_img.wc_reset_variation_attr('alt');
    //     $product_img.wc_reset_variation_attr('data-src');
    //     $product_img.wc_reset_variation_attr('data-large_image');
    //     $product_img.wc_reset_variation_attr('data-large_image_width');
    //     $product_img.wc_reset_variation_attr('data-large_image_height');
    //     $product_img_wrap.wc_reset_variation_attr('data-thumb');
    //     $gallery_img.wc_reset_variation_attr('src');
    //     $product_link.wc_reset_variation_attr('href');
    // };
    //
    // gallery_image_reset_attr = function (attr) {
    //     if (undefined !== this.attr('data-o_' + attr)) {
    //         this.attr(attr, this.attr('data-o_' + attr));
    //     }
    // };
    /*Image preview end */
    function wcpa_remove_file($field) {
        var details = $field.data('details');
        if (details.required === true) {
            $field.attr('required', 'required');
        }
        var $field_wraper = $field.parents('.wcpa_file_outer');
        $preview = $field.parents('.wcpa_form_item').find(".wcpa_upload_preview");
        if ($preview.length) {
            $preview.html('');
        }
        $("~ .wcpa_progress", $field_wraper).hide().css('width', 0);

        $("~ .wcpa_file_hidden", $field_wraper).val('');
        $field.parent().removeClass('wcpa_uploaded');
        $field.val('');
        $field.trigger('change');
        $field_wraper.find('.wcpa_file_name').removeClass('wcpa_file_error').html('');
    }

    function wcpa_upload_file($field) {
        var file_data = $field.prop('files')[0];

        if (typeof file_data === "undefined") {
            return;
        }
        if (typeof $field.data('wcpa_ajx_upload') === 'object') {
            $field.data('wcpa_ajx_upload').abort();
        }
        var filepath = $field.val();
        var m = filepath.match(/([^\/\\]+)$/);
        var filename = m[1];

        var $field_wraper = $field.parents('.wcpa_file_outer');

        $field_wraper.find('.wcpa_file_name').removeClass('wcpa_file_error').html(filename);
        $preview = $field.parents('.wcpa_form_item').find(".wcpa_upload_preview");
        if ($preview.length) {
            if (file_data) {
                var wcpareader = new FileReader();
                var parts = file_data.name.split('.');
                var extension = parts[parts.length - 1];
                if (['jpg', 'jpeg', 'png', 'gif', 'svg'].indexOf(extension.toLowerCase()) > -1) {
                    wcpareader.onload = function (e) {
                        $preview.html($('<img />').attr('src', e.target.result));
                    };

                    wcpareader.readAsDataURL(file_data);
                } else {
                    $preview.html('');
                }

            }
        }
        if (!$field.is('.wcpa_ajax_upload')) {
            return;
        }


        var form_data = new FormData();
        var details = $field.data('details');
        form_data.append('wcpa_file', file_data);
        form_data.append('wcpa_file_details', JSON.stringify(details));
        form_data.append('action', 'wcpa_ajax_upload');

        if (details.required === true) {
            $field.attr('required', 'required');
        }

        var ajx_upload = $.ajax({
            type: "POST",
            url: wcpa_global_vars.ajax_url,
            xhr: function () {
                var myXhr = $.ajaxSettings.xhr();
                if (myXhr.upload) {
                    myXhr.upload.addEventListener('progress', function (e) {
                        if (e.lengthComputable) {
                            var percentage = Math.round((e.loaded * 100) / e.total);
                            $("~ .wcpa_progress", $field_wraper).css('width', percentage + '%');
                        }
                    }, false);

                }
                return myXhr;
            },
            beforeSend: function () {
                $field.parents('.wcpa_form_item').addClass('wcpa_uploading');
                $field.parent().removeClass('wcpa_uploaded');
                $("~ .wcpa_progress", $field_wraper).show().css('width', 0);
                $("~ .wcpa_file_hidden", $field_wraper).val('');
                $field.parents('form').find('.single_add_to_cart_button').addClass('wcpa_disable_cart')
                var upload_count = parseInt($field.parents('form').find('.single_add_to_cart_button').data('wcpa-upload-count'));
                if (isNaN(upload_count)) {
                    upload_count = 1;
                } else {
                    upload_count++;
                }
                $field.parents('form').find('.single_add_to_cart_button').data('wcpa-upload-count', upload_count);
            },
            success: function (data) {
                $("~ .wcpa_progress", $field_wraper).show().css('width', 100);
                $field.parents('.wcpa_form_item').removeClass('wcpa_uploading');
                $("~ .wcpa_progress", $field_wraper).show();
                $field.val('');
                var upload_count = parseInt($field.parents('form').find('.single_add_to_cart_button').data('wcpa-upload-count'));
                if (isNaN(upload_count) || upload_count === 1) {
                    upload_count = 0;
                    $field.parents('form').find('.single_add_to_cart_button').removeClass('wcpa_disable_cart');
                } else {
                    upload_count--;
                }
                $field.parents('form').find('.single_add_to_cart_button').data('wcpa-upload-count', upload_count);

                if (data.status === true) {

                    $field.removeAttr('required');
                    $("~ .wcpa_progress", $field_wraper).css('width', '100%');
                    $("~ .wcpa_file_hidden", $field_wraper).val(data.file.file + '||' + data.file.file_name);
                    $field.parent().addClass('wcpa_uploaded');
                } else {
                    $("~ .wcpa_progress", $field_wraper).css('width', 0);
                    $field_wraper.find('.wcpa_file_name').addClass('wcpa_file_error').html(data.message);

                }
                // your callback here
            },
            error: function (error, ajaxOptions, thrownError) {
                // handle error

                $("~ .wcpa_progress", $field_wraper).show().css('width', 0);
                var upload_count = parseInt($field.parents('form').find('.single_add_to_cart_button').data('wcpa-upload-count'));
                if (isNaN(upload_count) || upload_count === 1) {
                    upload_count = 0;
                    $field.parents('form').find('.single_add_to_cart_button').removeClass('wcpa_disable_cart');
                } else {
                    upload_count--;
                }
                $field.parents('form').find('.single_add_to_cart_button').data('wcpa-upload-count', upload_count);
                if (thrownError !== 'abort') {
                    $field.val('');
                    $field_wraper.find('.wcpa_file_name').addClass('wcpa_file_error').html(wcpa_global_vars.strings.ajax_upload_error);
                }

                $field.parents('.wcpa_form_item').removeClass('wcpa_uploading');
            },
            async: true,
            data: form_data,
            dataType: 'json',
            cache: false,
            contentType: false,
            processData: false
        });

        $field.data('wcpa_ajx_upload', ajx_upload);


    }

    function regExpFromString(q, ext) {
        var flags = q.replace(/.*\/([gimuy]*)$/, '$1');
        if (flags === q) flags = '';
        var pattern = (q.charAt(0) == '/' ? q.replace(new RegExp('^/(.*?)/' + flags + '$'), '$1') : q);
        try {
            if (flags == '' && q.charAt(0) !== '/') {
                flags = ext;
            }
            return new RegExp(pattern, flags);
        } catch (e) {
            return null;
        }
    }

//    $(document).ready(function () {
//
//        if (typeof wcpa_global_vars !== 'undefined') {
//            if ($('.wcpa_datepicker').length) {
//                $('.wcpa_datepicker').each(function () {
//                    var dp_conf = $(this).data('dpconf');
//                    if (dp_conf == null) {
//                        dp_conf = {};
//                    }
//                    $(this).datetimepicker($.extend({
//                        timepicker: false,
//                        validateOnBlur: false,
//                        scrollInput: false,
//                        format: wcpa_global_vars.date_format
//                    }, dp_conf));
//                });
//
//
//            }
//            if ($('.wcpa_datetimepicker').length) {
//                $('.wcpa_datetimepicker').each(function () {
//                    var dp_conf = $(this).data('dpconf');
//                    if (dp_conf == null) {
//                        dp_conf = {};
//                    }
//                    $(this).datetimepicker($.extend({
//                        format: wcpa_global_vars.date_format + ' ' + wcpa_global_vars.time_format,
//                        validateOnBlur: false,
//                        scrollInput: false,
//                        step: 15
//                    }, dp_conf));
//
//                });
//
//            }
//            if ($('.wcpa_timepicker').length) {
//                $('.wcpa_timepicker').each(function () {
//                    var dp_conf = $(this).data('dpconf');
//                    if (dp_conf == null) {
//                        dp_conf = {};
//                    }
//                    $(this).datetimepicker($.extend({
//                        datepicker: false,
//                        format: wcpa_global_vars.time_format,
//                        validateOnBlur: false,
//                        scrollInput: false,
//                        step: 15
//                    }, dp_conf));
//
//                });
//
//            }
//            if ($('.wcpa_colorpicker').length) {
//                $(".wcpa_colorpicker").spectrum({
//                    preferredFormat: "hex",
//                    showInput: true,
//                    allowEmpty: true
//                });
//            }
//            if ($('.wcpa_google_place').length) {
//
//            }
//            if (typeof $.datetimepicker !== 'undefined' && document.documentElement.lang !== '') {
//                $.datetimepicker.setLocale(document.documentElement.lang.substring(0, 2));
//            }
//
//
//        }
//
//    });


    var total_price = 0;
    var total_fee = 0;
    var wcpa_price = function (price) {
       // return price.toFixed(wcpa_global_vars.wc_price_decimals).replace('.', wcpa_global_vars.wc_decimal_sep);
        return wcpa_number_format(price,wcpa_global_vars.wc_price_decimals,wcpa_global_vars.wc_decimal_sep,wcpa_global_vars.wc_thousand_sep);
    };

    function wcpa_number_format (number, decimals, dec_point, thousands_sep) {
        // Strip all characters but numerical ones.
        number = (number + '').replace(/[^0-9+\-Ee.]/g, '');
        var n = !isFinite(+number) ? 0 : +number,
            prec = !isFinite(+decimals) ? 0 : Math.abs(decimals),
            sep = (typeof thousands_sep === 'undefined') ? ',' : thousands_sep,
            dec = (typeof dec_point === 'undefined') ? '.' : dec_point,
            s = '',
            toFixedFix = function (n, prec) {
                var k = Math.pow(10, prec);
                return '' + Math.round(n * k) / k;
            };
        // Fix for IE parseFloat(0.55).toFixed(0) = 0;
        s = (prec ? toFixedFix(n, prec) : '' + Math.round(n)).split('.');
        if (s[0].length > 3) {
            s[0] = s[0].replace(/\B(?=(?:\d{3})+(?!\d))/g, sep);
        }
        if ((s[1] || '').length < prec) {
            s[1] = s[1] || '';
            s[1] += new Array(prec - s[1].length + 1).join('0');
        }
        return s.join(dec);
    }
    function exc_Label(ele, $form_outer) {
        if (typeof $form_outer === "undefined") {
            $form_outer = false;
        }
        if (typeof ele == 'string') {
            var $element = $("#" + ele, $form_outer);
        } else {
            var $element = ele;
        }


        var product_data = $form_outer.data("product")
        if ($element.length == 0) {
            return false;
        }
        var quantity = parseInt($form_outer.parents('form').find('input[name=quantity]').val());

        var $label = $element.find(".wcpa_paragraph_block").data('label');
        if (typeof $label == 'undefined' || typeof $label.label === 'undefined') {
            return false;
        }
        if ($label.label.match(/\#\=(.+?)\=\#/)) {
            var matches = $label.label.match(/\#\=(.+?)\=\#/g);
            var out = $label.label;
            for (var i in matches) {
                var mat = matches[i].match(/\#\=(.+?)\=\#/);
                if (mat[1]) {
                    var formula = calculate_price('custom', 1, mat[1], quantity, product_data, $element, false, true);
                    if (formula === '' || formula === '0') {
                        out = out.replace(mat[0], '');
                    } else {
                        try {
                            var res = eval(formula);
                            if (!isNaN(res) && res % 1 != 0) {
                                res = wcpa_price(res);
                            }
                            out = out.replace(mat[0], res);
                        } catch (e) {
                            out = out.replace(mat[0], formula);
                        }
                    }
                }
            }
            $element.find(".wcpa_paragraph_block").html(out)
        }

        // calculate_price(pricingType, value, price, quantity, $product_data, $ele, element_data) {
    }

    function exc_relations(ele_id, $form_outer) {
        if (typeof $form_outer === "undefined") {
            $form_outer = false;
        }

        var $element = $("#" + ele_id, $form_outer);
        var product_data = $form_outer.data("product")
        if ($element.length == 0) {
            return false;
        }
        var $relation = $element.data('rules');
        if (!$relation) {
            return false;
        }
        var $rules = $relation.rules;
        $evel_str = '';
        $rules.forEach(function (ele) {
            $evel_str += '(';
            ele.rules.forEach(function (el) {
                $evel_str += '(';
                if (eval_relation(el.rules, $element, product_data, $form_outer)) {
                    $evel_str += ' true ';
                } else {
                    $evel_str += ' false ';
                }
                $evel_str += ') ' + ((el.operator !== false) ? el.operator : '') + ' ';

            });

            if (ele.length > 0) {
                $evel_str = $evel_str.match(/\(.*\)/g)[0] + ' ';
            }


            $evel_str += ') ' + ((ele.operator !== false) ? ele.operator : '') + ' ';
        });

        if ($rules.length > 0) {
            $evel_str = $evel_str.match(/\(.*\)/g)[0];
        }


        var result = false;
        try {
            result = eval($evel_str.replace(/or/gi, '||').replace(/and/gi, '&&'));
        } catch (e) {
            return false;
        }
        if (result) {
            if ($relation.action == 'show') {
                enable_fields($element);
                if (!$element.is(":visible")) {
                    $element.show(0, function () {
                        $element.trigger('element_cl_updated');
                    }).addClass('wcpa_cl_visible');

                } else {
                    return true; // has no changes made, it returns here to avoid re-running the cl logic for this field
                }


            } else {
                disable_fields($element);
                $element.removeClass('wcpa_cl_visible')
                if ($element.is(":visible")) {
                    $element.hide(0, function () {
                        $element.trigger('element_cl_updated');
                    });

                } else {
                    return true; // has no changes made, it returns here to avoid re-running the cl logic for this field
                }

            }
        } else {
            if ($relation.action == 'show') {
                disable_fields($element);
                $element.removeClass('wcpa_cl_visible')
                if ($element.is(":visible")) {
                    $element.hide(0, function () {
                        $element.trigger('element_cl_updated');
                    });

                } else {
                    return true; // has no changes made, it returns here to avoid re-running the cl logic for this field
                }
            } else {
                enable_fields($element);
                if (!$element.is(":visible")) {
                    $element.show(0, function () {
                        $element.trigger('element_cl_updated');
                    }).addClass('wcpa_cl_visible');

                } else {
                    return true; // has no changes made, it returns here to avoid re-running the cl logic for this field
                }

            }
        }

        var related = $element.data('related');
        if (related != null) {
            related.forEach(function (el) {
                exc_relations(el, $form_outer);
            });
        }

        $form_outer.trigger('wcpa.cl_updated');
//        for (i in related) {
//            exc_relations(related[i]);
//        }
        iterate($element.parents(".wcpa_form_outer"));
    }

    function disable_fields($element) {
        $element.find('select,input,file,textarea').attr('disabled', 'disabled');
    }

    function enable_fields($element) {

        $element.find('select,input,file,textarea').removeAttr('disabled');
        if ($element.is('.wcpa_type_color')) {
            $(".wcpa_colorpicker", $element).spectrum({
                preferredFormat: "hex",
                showInput: true,
                allowEmpty: true
            });
        }
    }

    function eval_relation(rule, $element, product_data, $form_outer) {
        if (rule.cl_field === 'quantity') {
            var $field = $element.parents("form").find("input[name=quantity]");
        } else if (rule.cl_field === 'attribute') {
         
            var $field2 = typeof product_data.product_attributes[rule.cl_relation] != 'undefined' ? product_data.product_attributes[rule.cl_relation]['value'] : [];
            if (product_data.is_variable) {
                $dropdown = $element.parents("form.variations_form").find(".variations select[name='attribute_" + rule.cl_relation + "']");
                if ( $dropdown &&  $dropdown.length>0) {
                    var $field = $element.parents("form.variations_form").find(".variations select[name='attribute_" + rule.cl_relation + "']").val();
                    if($field){
                        $field = [$field];
                    }else {
                        $field = [];
                    }
                   
                } else {
                    $field =$field2;
                }
              //  $field = $field.concat($field2); 
            } else{
                $field = $field2; 
            }
           

        } else if (rule.cl_field === 'stock_status') {
            var $field = new Array();
            $field.push(product_data.stock_status);
        } else if (rule.cl_field === 'stock_quantity') {
            var $field = new Array();
            $field.push(product_data.stock_quantity);
        } else if (rule.cl_field === 'custom_field') {
            var $field = new Array();
            $field.push(product_data.product_cfs);
        } else if (rule.cl_field === 'product_ids') {
            var $field = new Array();
            $field.push(product_data.product_id);
        }
        else {
            var $field = $("#" + rule.cl_field, $form_outer);
        }

        if (!$field.length) {
            return false;
        }

        if (rule.cl_relation === '0') {
            return false;
        }
        var val = Array();

        if ($.inArray(rule.cl_field, ['stock_status', 'stock_quantity', 'custom_field', 'product_ids', 'attribute']) < 0 && ($field.is(":visible") || $.inArray($field.data('type'), ['hidden']) >= 0 || rule.cl_field == 'quantity')) {

            if ($.inArray($field.data('type'), ['text', 'color', 'hidden']) >= 0) {
                if ($field.find('input').val()) {
                    val.push($field.find('input').val().toLowerCase().trim());
                }

            } else if ($.inArray($field.data('type'), ['file']) >= 0) {
                if ($field.find('input').val()) {
                    val.push($field.find('input').val().split('\\').pop().toLowerCase());
                } else if ($field.parents('.wcpa_form_item').length) {
                    $temp = $field.parents('.wcpa_form_item').find('.wcpa_file_hidden').val();
                    if ($temp.split("||").length === 2) {
                        val.push($temp.split("||")[1].toLowerCase());
                    }
                }

            } else if ($.inArray($field.data('type'), ['number']) >= 0) {
                if ($field.find('input').val()) {
                    val.push(parseFloat($field.find('input').val().toLowerCase().trim()));
                }

            } else if (rule.cl_field === 'quantity') {
                if ($field.val()) {
                    val.push(parseFloat($field.val().toLowerCase().trim()));
                }


            } else if ($.inArray($field.data('type'), ['textarea']) >= 0) {
                if ($field.find('textarea').val()) {
                    val.push($field.find('textarea').val().toLowerCase().trim());
                }

            } else if ($.inArray($field.data('type'), ['checkbox-group', 'radio-group']) >= 0) {
                val = $field.find('input:checked').map(function () {
                    if ($(this).hasClass('wcpa_other')) {
                        if ($.inArray(rule.cl_relation, ['contains', 'not_contains', 'starts_with', 'ends_with']) >= 0) {
                            return $(this).val().replace('WCPAOTH ', '').toLowerCase();
                        }
                        return 'other';
                    } else {
                        return $(this).val().toLowerCase();
                    }

                }).get();
            } else if ($.inArray($field.data('type'), ['select']) >= 0) {
                if ($field.find('select').val() && $field.find('select').val().constructor === Array) {
                    val = $field.find('select').val().map(function (e) {
                        return e.toLowerCase();
                    });
                } else if ($field.find('select').val()) {
                    val.push($field.find('select').val().toLowerCase());
                }
            } else if ($.inArray($field.data('type'), ['date', 'datetime-local']) >= 0) {
                if ($field.find('input').val()) {
                    if ($.inArray(rule.cl_relation, ['contains', 'not_contains', 'starts_with', 'ends_with']) >= 0) {

                        val.push($field.find('input').val().toLowerCase());
                    } else {
                        var d = wcpa_get_date_obj($field.find('input').val(), 'wp');

                        if (typeof d.getTime === 'function') {
                            val.push(d.getTime());
                        }

                    }
                }

            } else if ($.inArray($field.data('type'), ['time']) >= 0) {
                if ($field.find('input').val()) {
                    if ($.inArray(rule.cl_relation, ['contains', 'not_contains', 'starts_with', 'ends_with']) >= 0) {
                        val.push($field.find('input').val().toLowerCase());
                    } else {
                        var d = new Date('1/1/2018 ' + $field.find('input').val());
                        val.push(d.getTime());
                    }
                }
            } else if ($.inArray($field.data('type'), ['image-group', 'color-group']) >= 0) {
                val = $field.find('input:checked').map(function () {
                    if ($(this).hasClass('wcpa_other')) {
                        if ($.inArray(rule.cl_relation, ['contains', 'not_contains', 'starts_with', 'ends_with']) >= 0) {
                            return $(this).val().replace('WCPAOTH ', '').toLowerCase();
                        }
                        return 'other';
                    } else {
                        return $(this).val().toLowerCase();
                    }

                }).get();
            }
        }

        var rel_val = false;
        if (rule.cl_field === 'attribute') {


            if ($field && $field.length) {
                val = $field.map(function (e) {
                    return e.toLowerCase();
                });
                rel_val = (rule.cl_val.value) ? rule.cl_val.value : rule.cl_val;
                if ($.inArray(rel_val, val) >= 0) {
                    return true;
                } else {
                    return false;
                }
            } else {
                return false;
            }

        } else if (rule.cl_field === 'stock_status') {
            val.push(product_data.stock_status);
        } else if (rule.cl_field === 'stock_quantity') {
            val.push(product_data.stock_quantity);
        } else if (rule.cl_field === 'product_ids') {
            val.push(product_data.product_id);
        } else if (rule.cl_field === 'custom_field') {
            if (typeof product_data.product_cfs["wcpa_pcf_" + rule.cl_relation] != "undefined") {
                val.push(product_data.product_cfs["wcpa_pcf_" + rule.cl_relation].toLowerCase());
                rel_val = (rule.cl_val.value) ? rule.cl_val.value : rule.cl_val;
                if ($.inArray(rel_val, val) >= 0) {
                    return true;
                } else {
                    return false;
                }
            } else {
                return false;
            }


        }

        if (val.length == 0) {
            switch (rule.cl_relation) {
                case 'is_empty':
                    if (val.length === 0 || val[0] === '' || val[0] === null) {
                        return true;
                    } else {
                        return false;
                    }
                case 'is_not_empty':
                    if (val.length === 0 || val[0] === '' || val[0] === null) {
                        return false;
                    } else {
                        return true;
                    }
                default:
                    return false;
            }
        }

        if (rule.cl_val && rule.cl_field === 'stock_status') {
            rel_val = (rule.cl_val.value) ? rule.cl_val.value : rule.cl_val;
        } else if (rule.cl_val && rule.cl_field === 'product_ids') {
            rel_val = (((rule.cl_val.value) ? rule.cl_val.value : rule.cl_val)).split(/[ ,]+/);
            rel_val = rel_val.map(function (x) {
                return parseInt(x, 10);
            });
        }
        else if (rule.cl_val && rule.cl_field === 'quantity' || rule.cl_field === 'stock_quantity') {
            rel_val = parseInt(((rule.cl_val.value) ? rule.cl_val.value : rule.cl_val));
        } else if (rule.cl_val && $field.data('type') == 'image-group') {
            rel_val = ((rule.cl_val.i) ? rule.cl_val.i : rule.cl_val).toLowerCase();
        } else if (rule.cl_val && ($field.data('type') == 'date' || $field.data('type') == 'datetime-local')) {
            if ($.inArray(rule.cl_relation, ['contains', 'not_contains', 'starts_with', 'ends_with']) >= 0) {
                rel_val = rule.cl_val.toLowerCase();
            } else {
                var d1 = wcpa_get_date_obj(rule.cl_val);
                rel_val = d1.getTime();
            }
        } else if (rule.cl_val && ($field.data('type') == 'time')) {
            if ($.inArray(rule.cl_relation, ['contains', 'not_contains', 'starts_with', 'ends_with']) >= 0) {
                rel_val = rule.cl_val.toLowerCase();
            } else {
                var d1 = new Date('1/1/2018 ' + rule.cl_val);
                rel_val = d1.getTime();
            }
        } else if (rule.cl_val && $field.data('type') == 'number') {
            rel_val = parseFloat(((rule.cl_val.value) ? rule.cl_val.value : rule.cl_val));
        } else if (rule.cl_val) {
            rel_val = ((rule.cl_val.value) ? rule.cl_val.value : rule.cl_val).toLowerCase();
        }

        switch (rule.cl_relation) {
            case 'is':
                if ($.inArray(rel_val, val) >= 0) {
                    return true;
                } else {
                    return false;
                }
            case 'is_not':
                if ($.inArray(rel_val, val) >= 0) {
                    return false;
                } else {
                    return true;
                }
            case 'is_in':
                if (Array.isArray(rel_val)) {

                    var is_in = rel_val.filter(function (e) {
                        if ($.inArray(e, val) >= 0) {
                            return true;
                        } else {
                            return false;
                        }
                    });
                    if (is_in.length > 0) {
                        return true;
                    } else {
                        return false;
                    }
                } else {
                    return false;
                }

            case 'is_not_in':
                if (Array.isArray(rel_val)) {
                    var is_in = rel_val.filter(function (e) {

                        if ($.inArray(e, val) >= 0) {
                            return true;
                        } else {
                            return false;
                        }
                    });
                    if (is_in.length > 0) {
                        return false;
                    } else {
                        return true;
                    }
                } else {
                    return false;
                }
            case 'is_empty':
                if (val.length === 0 || val[0] === '' || val[0] === null) {
                    return true;
                } else {
                    return false;
                }
            case 'is_not_empty':
                if (val.length === 0 || val[0] === '' || val[0] === null) {
                    return false;
                } else {
                    return true;
                }
            case 'is_greater':
                for (var i = 0; i < val.length; i++) {
                    if (parseFloat(val[i]) > parseFloat(rel_val)) {
                        return true;
                    }
                }
                return false;
            case 'is_lessthan':
                for (var i = 0; i < val.length; i++) {
                    if (parseFloat(val[i]) >= parseFloat(rel_val)) { // need to ensuer no values are greater
                        return false;
                    }
                }
                return true;
            case 'is_greater_or_eqaul':
                for (var i = 0; i < val.length; i++) {
                    if (parseFloat(val[i]) >= parseFloat(rel_val)) {
                        return true;
                    }
                }
                return false;
            case 'is_lessthan_or_eqal':
                for (var i = 0; i < val.length; i++) {
                    if (parseFloat(val[i]) > parseFloat(rel_val)) {
                        return false;
                    }
                }
                return true;
            case 'contains':
                for (var i = 0; i < val.length; i++) {
                    if (val[i].indexOf(rel_val) !== -1) {
                        return true;
                    }
                }
                return false;
            case 'not_contains':
                for (var i = 0; i < val.length; i++) {
                    if (val[i].indexOf(rel_val) !== -1) {
                        return false;
                    }
                }
                return true;
            case 'starts_with':
                for (var i = 0; i < val.length; i++) {
                    if (val[i].startsWith(rel_val)) {
                        return true;
                    }
                }
                return false;
            case 'ends_with':
                for (var i = 0; i < val.length; i++) {
                    if (val[i].endsWith(rel_val)) {
                        return true;
                    }
                }
                return false;
            case 'date_is':
            case 'time_is':
                if ($.inArray(rel_val, val) >= 0) {
                    return true;
                } else {
                    return false;
                }
            case 'date_is_before':
            case 'time_is_before':
                for (var i = 0; i < val.length; i++) {
                    if (parseFloat(val[i]) >= parseFloat(rel_val)) { // need to ensuer no values are greater
                        return false;
                    }
                }

                return true;
            case 'date_is_after':
            case 'time_is_after':
                for (var i = 0; i < val.length; i++) {
                    if (parseFloat(val[i]) > parseFloat(rel_val)) { // need to ensuer no values are greater
                        return true;
                    }
                }
                return false;

        }


    }

    //Iterating through each to wcpa_has_price to check and update price
    function iterate($form_outer, reset) {
//        var is_variable = $('.wcpa_form_outer').parents("form").hasClass(".variations_form");
//


        if (typeof reset === "undefined") {
            reset = true;
        }
        if (reset) {
            $('.wcpa_form_item', $form_outer).data("wcpa_price", false);
        }
        $form_outer.data('wcpa_deps_counter', 0);
        wcpa_may_update_quantity($form_outer);
        total_price = 0;
        total_fee = 0;

        $('.wcpa_has_price', $form_outer).each(function (i, obj) {

            if (!($(this).parent().is(":visible") || $(this).parents('.wcpa_form_item').is(".wcpa_visible") || $(this).parents('.wcpa_form_item').is(".wcpa_visible_parent"))) {
                return true;
            }
            var val = $(this).val();
            if ($(this).is('select')) {
                var $that = $(this);
                $(this).find('option').each(function () {
                    wcpa_update_price($(this), $form_outer.data('product'));
                });
            } else {
                wcpa_update_price($(this), $form_outer.data('product'));
            }

        });
        if ($form_outer.data('wcpa_deps_counter') > 0) {
            iterate($form_outer, false);
            return;
        }

        if ($('.wcpa_has_price', $form_outer).length) {
            var product_price = +($form_outer.data('product').wc_product_price);
            var wc_product_regular_price = +($form_outer.data('product').wc_product_regular_price);
            var con_unit = +($form_outer.data('product').con_unit);
            var form_rules = $form_outer.data('rules');
            var quantity = parseInt($form_outer.parents('form').find('input[name=quantity]').val());
            if (form_rules && form_rules.pric_overide_base_price === true) {
                var product_total = Math.max(product_price * con_unit, total_price);
            } else if (form_rules && form_rules.pric_overide_base_price_if_gt_zero === true && total_price > 0) {
                var product_total = total_price;
            } else if (form_rules && form_rules.pric_overide_base_price_fully === true) {
                var product_total = total_price;
            } else {
                var product_total = product_price * con_unit + total_price;
            }
            if (wcpa_global_vars.change_price_as_quantity) {
                $form_outer.parent().find(".wcpa_price_summary").find('.wcpa_options_total .price_value').text(wcpa_price((total_price - total_fee) * quantity + total_fee));
                $form_outer.parent().find(".wcpa_price_summary").find('.wcpa_product_total .price_value').text(wcpa_price(product_price * quantity * con_unit));
                if (wc_product_regular_price != product_price) {
                    $form_outer.parent().find(".wcpa_price_summary").find('.wcpa_product_total .wcpa_price_strike').text(wcpa_price(wc_product_regular_price * quantity * con_unit));
                }
                $form_outer.parent().find(".wcpa_price_summary").find('.wcpa_total .price_value').text(wcpa_price((product_total - total_fee) * quantity + total_fee));
            } else {
                $form_outer.parent().find(".wcpa_price_summary").find('.wcpa_options_total .price_value').text(wcpa_price(total_price));
                $form_outer.parent().find(".wcpa_price_summary").find('.wcpa_product_total .price_value').text(wcpa_price(product_price * con_unit));
                $form_outer.parent().find(".wcpa_price_summary").find('.wcpa_product_total .wcpa_price_strike').text(wcpa_price(product_price * con_unit));
                if (wc_product_regular_price != product_price) {
                    $form_outer.parent().find(".wcpa_price_summary").find('.wcpa_product_total .wcpa_price_strike').text(wcpa_price(wc_product_regular_price * con_unit));
                }
                $form_outer.parent().find(".wcpa_price_summary").find('.wcpa_total .price_value').text(wcpa_price(((product_total < 0) ? 0 : product_total)));
            }


            $form_outer.data('wcpa', {
                fee: total_fee,
                price:
                    {
                        options: total_price,
                        product: product_price,
                        total: product_total
                    }
            });
            $form_outer.trigger('wcpa.price_updated');


        }

        wcpa_may_update_quantity($form_outer);


        $('.wcpa_has_label_formula', $form_outer).each(function (i, obj) {
            if (!($(this).parent().is(":visible") || $(this).parents('.wcpa_form_item').is(".wcpa_visible") || $(this).parents('.wcpa_form_item').is(".wcpa_visible_parent"))) {
                return true;
            }
            exc_Label($(this).parents('.wcpa_form_item'), $form_outer);
        });
//        var $wcpa_queue = $form_outer.data('wcpa_queue');
//        if ($wcpa_queue) {
//            $wcpa_queue.forEach(function (el,index, object) {
//                wcpa_update_price($(".wcpa_has_price,#" + el));
//                object.splice(index, 1);
//            });
//        }

        if ($('.wcpa_update_product_image', $form_outer).length) {
            var is_image_updated = false;


            $($('.wcpa_update_product_image', $form_outer).get().reverse()).each(function () {
                if ($(this).is("select")) {
                    $ele = $(this).find("option:selected")
                    if (!$ele) {
                        return;
                    }
                } else if (!$(this).is(":checked")) {
                    return;
                } else {
                    $ele = $(this);
                }
                if ($(this).parents('.wcpa_form_item').is(":visible") || $(this).parents('.wcpa_form_item').hasClass("wcpa_cl_visible")) {
                    var image = $ele.data('image');
                    if (image && image.src) {
                        wcpa_product_image_update($form_outer.parents("form"), $ele);
                        is_image_updated = true;
                        return false;
                    }

                }
            });
            if (!is_image_updated) {
                wcpa_product_image_update($form_outer.parents("form"), false);
            }
        }
    }

    function wcpa_may_update_quantity($product_data) {
        var form_rules = $product_data.data('rules');
        if (form_rules.bind_quantity) {
            var $ele = $("input[name=quantity]", $product_data.parents("form"));
            if ($ele.length) {
                $ele.attr("readonly", "readonly");
                var value = calculate_price('custom', 1, form_rules.quantity_bind_formula, 1, $product_data, $ele);
                var prev_value = $ele.val();
                if (value > 0) {
                    $ele.val(value);
                } else {
                    $ele.val(1);
                }
                if (prev_value != $ele.val()) {
                    $ele.trigger("change");
                }
                // $ele.trigger("change");
            }

        }
    }

    function wcpa_update_price($ele, $product_data) {

        var element_data = $ele.data('price');
        var quantity = parseInt($ele.parents('form').find('input[name=quantity]').val());
        var elem_price = 0;
        var elem_price_sum = 0;
        if (!element_data) {
            var element_data = $ele.find(':selected').data('price')
        }
        if (!element_data) {
            element_data = {
                type: false,
                priceoptions: false,
                value: false,
                pricingType: false,
                taxpu: 1,
                con_unit: 1,
                is_show_price: false
            };

        }

        var value = $ele.val().trim();
        if ($.inArray(element_data.type, ['radio-group', 'checkbox-group', 'image-group', 'color-group']) >= 0 && !$ele.is(":checked")) {
            value = false;
        }

        if ($.inArray(element_data.type, ['select']) >= 0 && !$ele.is(":selected")) {
            value = false;
        }

        if ($ele.hasClass('wcpa_other') && $.inArray(element_data.type, ['radio-group', 'checkbox-group', 'image-group', 'color-group']) >= 0 && $ele.is(":checked")) {
            value = $ele.nextAll('.wcpa_other_val').val().trim();
        }
        if ($.inArray(element_data.type, ['paragraph', 'header']) >= 0) {
            value = 1;
        }
        if ($.inArray(element_data.type, ['file']) >= 0 && value == '') {
            if ($ele.parents('.wcpa_form_item').find('.wcpa_file_hidden').length) {
                if ($ele.parents('.wcpa_form_item').find('.wcpa_file_hidden').val() !== '') {
                    value = $ele.parents('.wcpa_form_item').find('.wcpa_file_hidden').val().split("||")[1]
                }

            }

        }

        elem_price = calculate_price(element_data.pricingType, value, element_data.value, quantity, $product_data, $ele, element_data);
        if ((element_data.pricingType == 'custom' || element_data.pricingType == 'percentage')) { // for all other type, tax wud have already applied
            if (element_data.taxpu) {
                elem_price = elem_price * element_data.taxpu;
            }

        }
        if (element_data.con_unit) {
            elem_price = elem_price * element_data.con_unit;
        }
        if (typeof element_data.is_show_price == "undefined" || element_data.is_show_price == false) {
            total_price += elem_price;
        }


        var field_price_multiplier = 1;
        if (typeof wcpa_global_vars.show_field_price_x_quantity !== 'undefined' && wcpa_global_vars.show_field_price_x_quantity) {
            field_price_multiplier = quantity;
        }
        if (element_data.is_fee !== undefined && element_data.is_fee === true) {
            total_fee += elem_price
            field_price_multiplier = 1;
        }


        $ele.data('elem_price', elem_price);

        if ($ele.is('option')) {
            $ele.parent().find(':checked').each(function () {
                elem_price_sum += ($(this).data('elem_price') ? $(this).data('elem_price') : 0);
            });
            $ele.parents('.wcpa_form_item').data('wcpa_price', elem_price_sum / (element_data.taxpu * element_data.con_unit)).find('.price_value').text(wcpa_price(elem_price_sum * field_price_multiplier));
        } else if (element_data.type == 'checkbox-group') {

            $ele.parents('.checkbox-group').find('input:checked').each(function () {
                elem_price_sum += ($(this).data('elem_price') ? $(this).data('elem_price') : 0);

            });
            $ele.parents('.wcpa_form_item').data('wcpa_price', elem_price_sum / (element_data.taxpu * element_data.con_unit)).find('.price_value').text(wcpa_price(elem_price_sum * field_price_multiplier));
        } else if (element_data.type == 'radio-group') {

            $ele.parents('.radio-group ').find('input:checked').each(function () {
                elem_price_sum += ($(this).data('elem_price') ? $(this).data('elem_price') : 0);

            });
            $ele.parents('.wcpa_form_item').data('wcpa_price', elem_price_sum / (element_data.taxpu * element_data.con_unit)).find('.price_value').text(wcpa_price(elem_price_sum * field_price_multiplier));
        } else if (element_data.type == 'image-group') {

            $ele.parents('.image-group ').find('input:checked').each(function () {
                elem_price_sum += ($(this).data('elem_price') ? $(this).data('elem_price') : 0);

            });
            $ele.parents('.wcpa_form_item').data('wcpa_price', elem_price_sum / (element_data.taxpu * element_data.con_unit)).find('.price_value').text(wcpa_price(elem_price_sum * field_price_multiplier));
        } else if (element_data.type == 'color-group') {

            $ele.parents('.color-group ').find('input:checked').each(function () {
                elem_price_sum += ($(this).data('elem_price') ? $(this).data('elem_price') : 0);

            });
            $ele.parents('.wcpa_form_item').data('wcpa_price', elem_price_sum / (element_data.taxpu * element_data.con_unit)).find('.price_value').text(wcpa_price(elem_price_sum * field_price_multiplier));
        } else {
            $ele.parents('.wcpa_form_item').data('wcpa_price', elem_price / (element_data.taxpu * element_data.con_unit)).find('.price_value').text(wcpa_price(elem_price * field_price_multiplier));
        }
        $ele.parents('.wcpa_form_item').trigger('wcpa.item_price_updated');
//        if ($ele.parents('.wcpa_form_item').data('price_depends')) {
//            $ele.parents('.wcpa_form_item').data('price_depends').forEach(function (el) {
//
//                if ($("#" + el).length) {
//                    var $wcpa_queue = $form_outer.data('wcpa_queue');
//
//                    if ($wcpa_queue == undefined || $wcpa_queue == null) {
//                        $wcpa_queue = new Array();
//                    }
//                    // if (!($.inArray(el, $wcpa_queue) >= 0)) {
//                    $wcpa_queue.push(el)
//                    $form_outer.data('wcpa_queue', $wcpa_queue);
//                    //  }
//                }
//            });
//        }


    }

    function calculate_price(pricingType, value, price, quantity, $product_data, $ele, element_data, isLabel) {
        if (typeof element_data == 'undefined') {
            var element_data = {};
        }
        if (typeof isLabel == 'undefined') {
            var isLabel = false;
        }
        if (pricingType !== 'custom') {

            if (price !== null && price !== false && typeof price === 'string') {
                price = parseFloat(price.replace(wcpa_global_vars.wc_decimal_sep, '.'));
            }
            if (isNaN(price)) {
                price = 0.0;
            }
        }

        var elem_price = 0;
        switch (pricingType) {
            case 'fixed':
                if (value) {
                    elem_price = +price; //added + sign to convert to int/float value
                } else {
                    elem_price = 0;
                }

                break;
            case 'per_car':
                var value_filtered = value;
                if (typeof element_data.excl_chars_frm_length !== 'undefined' && element_data.excl_chars_frm_length.length > 0) {
                    if (typeof element_data.excl_chars_frm_length_is_regex !== 'undefined' && element_data.excl_chars_frm_length_is_regex) {
                        var exclude_chars = element_data.excl_chars_frm_length;
                        var re = regExpFromString(exclude_chars, 'gi');
                        value_filtered = value_filtered.replace(re, '');
                    } else {
                        var exclude_chars = element_data.excl_chars_frm_length.replace(/\\s/g, ' ');
                        exclude_chars = exclude_chars.split('').map(function (e) {
                            if (e == ' ') {
                                var re = new RegExp('\\s', "g");
                                value_filtered = value_filtered.replace(re, '');
                            } else if (e == '.') {
                                value_filtered = value_filtered.replace(/\./, '');
                            } else {
                                var re = new RegExp(e, "g");
                                value_filtered = value_filtered.replace(re, '');

                            }
                            return e;
                        })
                    }


                }
                elem_price = value_filtered.length * price;
                break;
            case 'multiply':
                if (value) {
                    elem_price = (+price) * (isNaN(value) ? 1 : value); //added + sign to convert to int/float value
                } else {
                    elem_price = 0;
                }
                if (elem_price < 0) {
                    elem_price = 0; // dont allow go -ve, use custom formula for setting -ve
                }
                break;
            case 'custom':
                if (value !== false && value !== '' && value !== null) {
                    $ele_outer = $ele.parents(".wcpa_form_item");
                    if (typeof moment == 'function') {
                        var today = {seconds: moment().unix()};
                    } else {
                        var today = {seconds: wcpa_global_vars.today.seconds};
                    }

                    var formula = price.replace(/{this.value}/g, value)
                        .replace(/{value}/g, value)
                        .replace(/{quantity}/g, quantity)
                        .replace(/{this.value.length}/g, value.length)
                        .replace(/{value.length}/g, value.length)
                        .replace(/{product_price}/g, $product_data.wc_product_price)
                        .replace(/{days}/g, date_data_from_field('days', $ele_outer))
                        .replace(/{seconds}/g, date_data_from_field('seconds', $ele_outer))
                        .replace(/{timestamp}/g, date_data_from_field('timestamp', $ele_outer))
                        .replace(/{today.days}/g, wcpa_global_vars.today.days)
                        .replace(/{today.seconds}/g, today.seconds)

                        .replace(/{this.count}/g, get_data_from_field('count', $ele));

                    if (formula.match(/\{(\s)*?wcpa_pcf_([^}]*)}/)) {
                        var cf_matches = formula.match(/\{(\s)*?wcpa_pcf_([^}]*)}/g);
                        for (var i in cf_matches) {
                            var mat = cf_matches[i].match(/\{(\s)*?([^}]*)}/);
                            if (mat[2] !== undefined && typeof mat[2] == 'string' && typeof $product_data.product_cfs[mat[2].trim()] !== 'undefined') {
                                var myReg = new RegExp(mat[0]);
                                formula = formula.replace(myReg, $product_data.product_cfs[mat[2].trim()]);
                            } else {
                                var myReg = new RegExp(mat[0]);
                                formula = formula.replace(myReg, 0);
                            }

                        }
                    }
                    if (formula.match(/\{(\s)*?field\.([^}]*)}/)) {
                        var matches = formula.match(/\{(\s)*?field\.([^}]*)}/g);

                        for (var i in matches) {
                            var mat = matches[i].match(/\{(\s)*?field\.([^}]*)}/);

                            if (mat[2] !== undefined && typeof mat[2] == 'string') {
                                var ele = mat[2].split(".");
                                if (ele.length > 1 && $.inArray(ele[1], ['value', 'price', 'count', 'days', 'seconds', 'timestamp']) >= 0) {
                                    var $ele = $("#" + ele[0]);

                                    if ($ele.length) {
                                        var val = 0;
                                        if ($ele.is(":visible") || $ele.data("type") == 'hidden') {
                                            switch (ele[1]) {
                                                case 'price':
                                                    if ($ele.find(".wcpa_has_price").length) {
                                                        if ($ele.data('wcpa_price') === undefined || $ele.data('wcpa_price') === false) {
                                                            elem_price = 0;

                                                            var wcpa_deps_counter = $ele.parents(".wcpa_form_outer").data('wcpa_deps_counter')
                                                            wcpa_deps_counter = (wcpa_deps_counter === undefined) ? 0 : wcpa_deps_counter;
                                                            wcpa_deps_counter = wcpa_deps_counter + 1;
                                                            $ele.parents(".wcpa_form_outer").data('wcpa_deps_counter', wcpa_deps_counter)
                                                            return elem_price;
                                                        } else {
                                                            val = $ele.data('wcpa_price');
                                                        }
                                                    }
                                                    break;
                                                case 'value':
                                                    switch ($ele.data('type')) {
                                                        case 'select' :
                                                            val = (($ele.find('select').val()) ? $ele.find('select').val() : 0);
                                                            break;
                                                        case 'textarea' :
                                                            val = (($ele.find('textarea').val()) ? $ele.find('textarea').val() : 0);
                                                            break;
                                                        case 'checkbox-group' :
                                                        case 'radio-group' :
                                                        case 'color-group' :
                                                        case 'image-group' :
                                                            val = 0.0;
                                                            if ($ele.find('input:checked').length) {
                                                                if ($ele.find('input:checked').length == 1) {
                                                                    if (isNaN($ele.find('input:checked').val())) {
                                                                        val = $ele.find('input:checked').val();
                                                                    } else {
                                                                        val = val + parseFloat($ele.find('input:checked').val());
                                                                    }
                                                                } else {
                                                                    $ele.find('input:checked').each(function (index) {
                                                                        if (!isNaN($(this).val())) {//sum if the values are numbers
                                                                            val = val + parseFloat($(this).val());
                                                                        } else if (index == 0) { // if the values are not number, take first value only
                                                                            val = $(this).val();
                                                                            return false;
                                                                        }

                                                                    })
                                                                }

                                                            } else {
                                                                val = 0;
                                                            }
                                                            break;

                                                        default:
                                                            val = (($ele.find('input').val()) ? $ele.find('input').val() : 0);
                                                            break;
                                                    }
                                                    if (typeof ele[2] !== "undefined") {
                                                        switch (ele[2]) {
                                                            case 'length':

                                                                val = val.length;
                                                                break;
                                                        }
                                                    }
                                                    break;
                                                case 'count':
                                                    switch ($ele.data('type')) {
                                                        case 'select' :
                                                            val = (($ele.find('select').val()) ? 1 : 0);
                                                            break;
                                                        case 'textarea' :
                                                            val = (($ele.find('textarea').val()) ? 1 : 0);
                                                            break;
                                                        case 'checkbox-group' :
                                                        case 'radio-group' :
                                                        case 'color-group' :
                                                        case 'image-group' :
                                                            val = 0.0;
                                                            if ($ele.find('input:checked').length) {
                                                                if ($ele.find('input:checked').length == 1) {

                                                                    val = 1;
                                                                } else {
                                                                    val = $ele.find('input:checked').length;

                                                                }

                                                            } else {
                                                                val = 0;
                                                            }
                                                            break;

                                                        default:
                                                            val = (($ele.find('input').val()) ? 1 : 0);
                                                            break;
                                                    }
                                                    break;
                                                case 'days':
                                                case 'seconds':
                                                case 'timestamp':
                                                    switch ($ele.data('type')) {
                                                        case 'date' :
                                                        case 'datetime-local' :
                                                            val = date_data_from_field(ele[1], $ele)
                                                            break;
                                                        default:
                                                            val = 0
                                                            break;
                                                    }
                                                    break;
                                            }
                                        }

                                    } else {
                                        var val = 0;
                                        //return elem_price;
                                    }
                                    var myReg = new RegExp(mat[0]);
                                    if (isNaN(val) && !isLabel) {
                                        formula = formula.replace(myReg, "'" + val + "'");
                                    } else {
                                        formula = formula.replace(myReg, val);
                                    }

                                }
                            }
                        }
                    }
                    if (isLabel) {
                        return formula;
                    }
                    try {
                        elem_price = eval(formula);
                    } catch (e) {
                        elem_price = 0;
                    }
                } else {
                    if (isLabel) {
                        return '';
                    }
                    elem_price = 0;
                }


                break;
            case 'percentage':
                if (value) {
                    elem_price = (price * $product_data.wc_product_price) / 100;
                } else {
                    elem_price = 0;
                }
                break;
        }
        return elem_price;
    }

    function wcpa_get_date_obj(val, date_format) {
        date_format = typeof date_format !== 'undefined' ? date_format : false;
        if (typeof moment == 'function') {
            if (date_format == 'wp') {
                return moment(val, wcpa_global_vars.date_format_js + ' ' + wcpa_global_vars.time_format_js).toDate();
            } else if (date_format !== false) {
                return moment(val, date_format).toDate();
            } else {
                return moment(val).toDate();
            }

        }
        return new Date(val);
    }

    function date_data_from_field(item, $ele_outer) {
        var val = 0;


        switch ($ele_outer.data('type')) {
            case 'date' :
            case 'datetime-local' :
            case 'time' :
                if (item == 'days') {

                    var d = wcpa_get_date_obj($ele_outer.find('input').val(), 'wp');

                    if (typeof d.getTime === 'function' && !isNaN(d.getTime())) {
                        val = (d.getTime() - new Date("1970/01/01").getTime()) / (1000 * 24 * 60 * 60);
                    } else {
                        val = 0;
                    }

                } else if (item == 'timestamp' || item == 'seconds') {
                    var d = wcpa_get_date_obj($ele_outer.find('input').val(), 'wp');
                    if (typeof d.getTime === 'function' && !isNaN(d.getTime())) {
                        val = (d.getTime() - new Date("1970/01/01").getTime()) / (1000);
                    } else {
                        val = 0;
                    }
                }
                break;

            default:
                val = 0;
                break;

        }
        return val;
    }

    function get_data_from_field(item, $ele) {

        $ele_outer = $ele.parents(".wcpa_form_item");
        val = 0;
        switch ($ele_outer.data('type')) {
            case 'select' :
                if (item == 'count') {
                    val = (($ele_outer.find('select').val()) ? 1 : 0);
                }
                break;
            case 'textarea' :
                if (item == 'count') {
                    val = (($ele.val()) ? 1 : 0);
                }
                break;
            case 'checkbox-group' :
            case 'radio-group' :
            case 'color-group' :
            case 'image-group' :
                if (item == 'count') {
                    val = 0.0;
                    if ($ele_outer.find('input:checked').length) {
                        if ($ele_outer.find('input:checked').length == 1) {

                            val = 1;
                        } else {
                            val = $ele_outer.find('input:checked').length;

                        }

                    } else {
                        val = 0;
                    }
                }
                break;

            default:
                if (item == 'count') {
                    val = (($ele_outer.find('input').val()) ? 1 : 0);
                }
                break;

        }
        return val;
    }

    function preview_image() {

        /*Image preview on mouse hover*/
        var xOffset = 10;
        var yOffset = 30;

        jQuery(".wcpa_type_image-group .wcpa_image .wcpa_img_mag").not(".wcpa_even_binded").on('click', function (e) {
            var title = $(this).parents('.wcpa_image').find('label').text();
            var caption = title ? title : '';
            jQuery("body").append("<div id='wcpa_img_popup_outer'><div class='wcpa_img_popup'><img src='" + $(this).attr('data-src') + "' alt='Image preview' />" + caption + "</div></div>");
            jQuery("#wcpa_img_popup_outer")
                .fadeIn("fast").on('click', function () {
                $(this).fadeOut("fast").remove();
            });

        }).addClass("wcpa_even_binded");
        jQuery(".wcpa_img_preview .wcpa_image img,.wcpa_cart_img_preview img").not(".wcpa_even_binded").hover(function (e) {
                var title = $(this).parent('.wcpa_image').find('label').text();
                var caption = title ? title : '';
                jQuery("body").append("<div id='wcpa_img_preview'><img src='" + $(this).data('src') + "' alt='Image preview' />" + caption + "</div>");
                jQuery("#wcpa_img_preview")
                    .css("top", (e.pageY - xOffset) + "px")
                    .css("left", (e.pageX - yOffset - jQuery("#wcpa_img_preview").width()) + "px")
                    .fadeIn("fast");
            },
            function () {

                jQuery("#wcpa_img_preview").remove();
            }).addClass("wcpa_even_binded");
        jQuery(".wcpa_img_preview .wcpa_image img,.wcpa_cart_img_preview img").not(".wcpa_even_binded").mousemove(function (e) {
            var view_port = $(window).scrollTop() + $(window).height()
            var image_bottom = (e.pageY + jQuery("#wcpa_img_preview").height());
            var image_top = (e.pageY - jQuery("#wcpa_img_preview").height());

            if (($(window).scrollTop() - image_top) < (image_bottom - view_port)) {
                var top = (e.pageY - xOffset - jQuery("#wcpa_img_preview").height());
            } else {
                var top = (e.pageY + xOffset);
            }
           

            if ((e.pageX - jQuery("#wcpa_img_preview").width()) < 0 && ($(window).width() - (e.pageX + jQuery("#wcpa_img_preview").width())) > (e.pageX - jQuery("#wcpa_img_preview").width())) {
                var left = (e.pageX + yOffset);
                jQuery("#wcpa_img_preview")
                .css("top", top + "px")
                .css("right",  "auto")
                .css("left", left + "px");
            } else {
                // var left = (e.pageX - yOffset - jQuery("#wcpa_img_preview").width());
                var right = $(window).width()-(e.pageX + yOffset);
                jQuery("#wcpa_img_preview")
                .css("top", top + "px")
                .css("left",  "auto")
                .css("right", right + "px");
            }

        
        }).addClass("wcpa_even_binded");
        /*end of image preview on mouse hover*/
    }

    $.wcpaInit = function () {
        preview_image();

        $(".cart_item.wcpa_bind_quantity.wcpa_cart_has_fields .quantity .qty").attr("readonly", "readonly");
        $(".wcpa_tooltip_icon").not(".wcpa_even_binded").hover(function () {
            $that = $(this)
            setTimeout(function () {
                $ele = $('.wcpa_tooltip', $that).get(0);
                if (typeof  $ele.getBoundingClientRect === 'function') {
                    var bounds = $ele.getBoundingClientRect();

                    if (bounds.x + bounds.width > $(window).width()) {
                        $('.wcpa_tooltip', $that).css("left", "-" + Math.min((bounds.x - parseInt(($(window).width() - bounds.width) / 2)), bounds.width - 20) + 'px')
                        $('.wcpa_tooltip', $that).css("border-radius", "5px")
                    }
                }

            }, 0);
        }, function () {
            $('.wcpa_tooltip', $that).css("left", "2px")
            $('.wcpa_tooltip', $that).css("border-radius", "5px 5px 5px 0")
        }).addClass("wcpa_even_binded");
        $(".wcpa_form_outer").each(function () {
          var  $form_outer = $(this);
            if ($form_outer.data('wcpa') !== undefined) {
                return true;
            }


//            $form_outer.on("wcpa_form_outer_changed", function () {
//                $form_outer.data('product', $form_outer.attr('data-product'));
//            })
//            $form_outer.parents('form').on("submit", function (e) {
//                return wcpa_validate($(this), $form_outer, e);
//            })

            if (typeof wcpa_global_vars !== 'undefined') {
                if ($('.wcpa_datepicker', $form_outer).length) {
                    $('.wcpa_datepicker', $form_outer).each(function () {
                        var dp_conf = $(this).data('dpconf');
                        if (dp_conf == null) {
                            dp_conf = {};
                        }


                        $(this).datetimepicker($.extend({
                            timepicker: false,
                            validateOnBlur: false,
                            scrollInput: false,
                            dayOfWeekStart: wcpa_global_vars.start_of_week,
                            format: wcpa_global_vars.date_format
                        }, dp_conf));
                    });


                }
                if ($('.wcpa_datetimepicker', $form_outer).length) {
                    $('.wcpa_datetimepicker', $form_outer).each(function () {
                        var dp_conf = $(this).data('dpconf');
                        if (dp_conf == null) {
                            dp_conf = {};
                        }
                        $(this).datetimepicker($.extend({
                            format: wcpa_global_vars.date_format + ' ' + wcpa_global_vars.time_format,
                            validateOnBlur: false,
                            dayOfWeekStart: wcpa_global_vars.start_of_week,
                            scrollInput: false,
                            step: 15
                        }, dp_conf));

                    });

                }
                if ($('.wcpa_timepicker', $form_outer).length) {
                    $('.wcpa_timepicker', $form_outer).each(function () {
                        var dp_conf = $(this).data('dpconf');
                        if (dp_conf == null) {
                            dp_conf = {};
                        }
                        $(this).datetimepicker($.extend({
                            datepicker: false,
                            format: wcpa_global_vars.time_format,
                            validateOnBlur: false,
                            scrollInput: false,
                            step: 15
                        }, dp_conf));

                    });

                }
                if ($('.wcpa_colorpicker', $form_outer).length) {
                    $(".wcpa_colorpicker", $form_outer).spectrum({
                        preferredFormat: "hex",
                        showInput: true,
                        allowEmpty: true,

                    });
                }

                if (typeof $.datetimepicker !== 'undefined' && document.documentElement.lang !== '') {
                    $.datetimepicker.setLocale(document.documentElement.lang.substring(0, 2));
                }
                if (wcpa_global_vars.use_sumo) {
                    $('.wcpa_type_select .select select').each(function () {
                        if ($(this).attr("multiple")) {
                            if ($(this).data('placeholder')) {
                                $(this).SumoSelect(
                                    {
                                        placeholder: $(this).data('placeholder'),
                                        captionFormat: wcpa_global_vars.strings.sumo_strings.captionFormat,
                                        captionFormatAllSelected: wcpa_global_vars.strings.sumo_strings.captionFormatAllSelected
                                    });
                            } else {
                                $(this).SumoSelect({
                                    captionFormat: wcpa_global_vars.strings.sumo_strings.captionFormat,
                                    captionFormatAllSelected: wcpa_global_vars.strings.sumo_strings.captionFormatAllSelected
                                });
                            }
                        }


                    });

                }


            }

            $(".wcpa_type_checkbox-group .wcpa_has_val_rules input,\n\
            .wcpa_type_radio-group .wcpa_has_val_rules input,\n\
            .wcpa_type_image-group .wcpa_has_val_rules input,\n\ \n\
  .wcpa_type_color-group .wcpa_has_val_rules input", $form_outer).on('change', function () {
                $item = $(this).parents(".wcpa_has_val_rules");
                $rules = $item.data('val_rules');
                if ($rules.selection !== undefined && $rules.selection.min !== undefined && $rules.selection.min > 0) {
                    if ($("input[type=checkbox]:checked", $item).length <= $rules.selection.min) {
                        wcpa_remove_val_error($item)

                    }
                }

                if ($rules.selection !== undefined && $rules.selection.max !== undefined && $rules.selection.max > 0) {
                    if ($("input[type=checkbox]:checked", $item).length > $rules.selection.max) {
                        wcpa_show_val_error($item, wcpa_global_vars.strings.sel_max_req_error.replace('%d', $rules.selection.max));
                        $(this).prop('checked', false);
                    }
                }


            })
            $form_outer.parents('form').on('submit', function (e) {
                var $status = true;


                $(".wcpa_datepicker", $(this)).each(function () {
                    if ($(this).val().indexOf("__") !== -1 && $(this).attr('required') == 'required') {
                        wcpa_show_val_error($(this), wcpa_global_vars.strings.field_is_requied);
                        $status = false;
                    }
                });

                $(".wcpa_has_val_rules", $(this)).each(function () {
                    $item = $(this);
                    $rules = $item.data('val_rules');
                    if ($rules.selection !== undefined && $rules.selection.max !== undefined && $rules.selection.max > 0) {
                        if ($item.is(":visible") && $("input[type=checkbox]:checked", $item).length > $rules.selection.max) {
                            wcpa_show_val_error($item, wcpa_global_vars.strings.sel_max_req_error.replace('%d', $rules.selection.max));
                            $status = false;
                        }
                    }
                    if ($rules.selection !== undefined && $rules.selection.min !== undefined && $rules.selection.min > 0) {
                        if ($item.is(":visible") && $("input[type=checkbox]:checked", $item).length < $rules.selection.min) {
                            wcpa_show_val_error($item, wcpa_global_vars.strings.sel_min_req_error.replace('%d', $rules.selection.min));
                            $status = false;
                        }
                    }
                });
                if ($status == false) {
                    e.preventDefault();
                    alert(wcpa_global_vars.strings.fix_val_errors);
                    return false;
                }
            })

            $(".wcpa_type_checkbox-group .wcpa_required input,\n\
            .wcpa_type_radio-group .wcpa_required input,\n\
            .wcpa_type_image-group .wcpa_required input,\n\ \n\
  .wcpa_type_color-group .wcpa_required input", $form_outer).on('change', function () {
                var $item = $(this).parents(".wcpa_form_item");

                // var ua = navigator.userAgent.toLowerCase();
                // if (ua.indexOf('safari') != -1) {
                //     if (ua.indexOf('chrome') != -1) {
                //         $(".wcpa_required input[type=checkbox]:first", $item).removeAttr("required");
                //     }
                // }
                if ($(".wcpa_required input[type=checkbox]", $item).length) {
                    if ($(".wcpa_required input[type=checkbox]:checked", $item).not(".wcpa_other").length == 0
                        &&
                        ($(".wcpa_required .wcpa_other_val", $item).length == 0 || $(".wcpa_required .wcpa_other_val", $item).val() == '')) {
                        $(".wcpa_required input[type=checkbox]:first", $item).attr("required", "required");

                    } else {
                        $(".wcpa_required input[type=checkbox]:first", $item).removeAttr("required");
                    }

                } else if ($(".wcpa_required input[type=radio]", $item).length) {
                    if ($(".wcpa_required input[type=radio]:checked", $item).not(".wcpa_other").length == 0
                        &&
                        ($(".wcpa_required .wcpa_other_val", $item).length == 0 || $(".wcpa_required .wcpa_other_val", $item).val() == '')) {
                        $(".wcpa_required input[type=radio]:first", $item).attr("required", "required");
                        if ($(".wcpa_required input[type=radio].wcpa_other", $item).is(":checked")) {
                            $(".wcpa_required .wcpa_other_val", $item).attr("required", "required");
                        }

                    } else {
                        $(".wcpa_required input[type=radio]:first", $item).removeAttr("required");
                        $(".wcpa_required .wcpa_other_val", $item).removeAttr("required");
                    }

                }
            })


            $(".wcpa_file_custom", $form_outer).on('keyup change', function () {
                wcpa_upload_file($(this));
            });
            $(".wcpa_progress span", $form_outer).on('click', function () {
                wcpa_remove_file($(this).parents('.wcpa_form_item').find('.wcpa_file_custom'))
            });
            $(".wcpa_clearSelection", $form_outer).on('click', function (e) {
                $("input", $("#" + $(this).data('element'))).prop("checked", false);
                $("input", $("#" + $(this).data('element'))).trigger('change');
                e.preventDefault();

            });

            $(".wcpa_allowed_chars", $form_outer).on('keyup change', function () {
                var val = jQuery(this).val();
                var new_val = '';
                var validation = $(this).data('validation');
                var allowed_chars = regExpFromString(validation.allowed_chars, 'i');
                var un_supported = '';
                for (var i = 0; i < val.length; i++) {
                    //	alert(val.charAt(i).match());
                    if (allowed_chars.test(val.charAt(i))) {
                        new_val += val.charAt(i);
                    } else {
                        un_supported += val.charAt(i);
                        var msg = wcpa_global_vars.strings.character_not_valid.replace('%s', un_supported)
                        if (typeof $error_ele !== 'undefined') {
                            $error_ele.remove();
                        }
                        $error_ele = $('<div class="wcpa_error_msg"><p>' + msg + '</p></div>').insertAfter($(this));
                        setTimeout(function () {
                            $error_ele.fadeOut(1000, function () {
                                jQuery(this).remove();
                            })
                        }, 1500);
                    }
                }

                jQuery(this).val(new_val);

            });


            $(".image-group .wcpa_image img", $form_outer).on('click', function () {
                var checkBoxes = $("#" + $(this).attr('attrfor'));

                checkBoxes.prop("checked", !checkBoxes.prop("checked"));
                checkBoxes.trigger('change');

            });
            $(".color-group .wcpa_color label", $form_outer).on('click', function () {
                var checkBoxes = $("#" + $(this).attr('for'));
                var is_checked = checkBoxes.prop("checked");
                setTimeout(function () {
                    if (is_checked) {
                        checkBoxes.prop("checked", false);
                        checkBoxes.trigger('change');
                    }
                }, 0)

                // checkBoxes.prop("checked", !checkBoxes.prop("checked"));
                checkBoxes.trigger('change');

            });

            $(".wcpa_other_val", $form_outer).on('keyup change', function () {
                if ($.trim($(this).val()).length > 0) {
                    $(this).siblings('.wcpa_other').val('WCPAOTH ' + $(this).val());
                } else {
                    $(this).siblings('.wcpa_other').val('');
                }

            });

            if (typeof wcpa_global_vars != 'undefined' && $form_outer.data("product").is_variable) {
                var form = $form_outer.parents("form").find('.single_variation_wrap');
                form.on('show_variation', function (event, variation) {
                    var prod_data = $form_outer.data("product");
                    // if(jQuery('.woocs_price_code').length>0){
                    //     prod_data.wc_product_price = variation.display_price;
                    // }else{
                    //     prod_data.wc_product_price = variation.display_price / prod_data.con_unit;
                    // }
                    prod_data.wc_product_price = variation.display_price / prod_data.con_unit;
                    prod_data.stock_status = variation.stock_status;
                    prod_data.stock_quantity = variation.stock_quantity;
                    $form_outer.data("product", prod_data)
                    iterate($form_outer);
                });
                $form_outer.parents("form").on('reset_data', function (event) {
                    var prod_data = $form_outer.data("product");
                    prod_data.wc_product_price = prod_data.wc_product_price_default;// / prod_data.con_unit;
                    $form_outer.data("product", prod_data)
                    iterate($form_outer);
                });
                $form_outer.parents("form").on('reset_image', function (event) {
                    setTimeout(function () {
                        iterate($form_outer);
                    }, 0)
                });


                $form_outer.parents("form").on('woocommerce_variation_has_changed', function (e) {
                    var $_form_outer = $(this).find('.wcpa_form_outer');
                    var related = $_form_outer.data('attrrelated');
                    if (related != null) {
                        related.forEach(function (el) {
                            exc_relations(el, $_form_outer);
                        });
                    }

                })

            }

            $([".wcpa_has_price",
                ".wcpa_has_price ~ .wcpa_other_val",
                ".wcpa_has_price_related input",
                ".wcpa_has_price_related select",
                ".wcpa_has_price_related textarea",

            ].join(','), $form_outer).on('keyup change', function () {
                var $_form_outer = $(this).parents('.wcpa_form_outer');
                iterate($_form_outer);
            });

            $(".wcpa_update_product_image", $form_outer).on('keyup change', function () {
                var $_form_outer = $(this).parents('.wcpa_form_outer');
                iterate($_form_outer);
            });


            if ($("input[name=quantity]", $form_outer.parents("form")).length) {
                var related = $form_outer.data('qntyrelated');
                if (related != null) {
                    related.forEach(function (el) {
                        exc_relations(el, $form_outer);
                    });
                }
            }
            $("input[name=quantity]", $form_outer.parents("form")).on('keyup change', function () {
                var related = $form_outer.data('qntyrelated');
                if (related != null) {
                    related.forEach(function (el) {
                        exc_relations(el, $form_outer);
                    });
                }
                iterate($form_outer);
            })

            $(".wcpa_has_relation input,.wcpa_has_relation select,.wcpa_has_relation textarea", $form_outer).on('keyup change', function () {
                var $_form_outer = $(this).parents('.wcpa_form_outer');
                var related = $(this).parents('.wcpa_has_relation').data('related');
                if (related != null) {
                    related.forEach(function (el) {
                        exc_relations(el, $_form_outer);
                    });
                }

            });

            $('.wcpa_has_relation', $form_outer).each(function () {
                var related = $(this).data('related');
                if (related != null) {
                    related.forEach(function (el) {
                        exc_relations(el, $form_outer);
                    });
                }

            })

            $([
                ".wcpa_has_label_related input",
                ".wcpa_has_label_related select",
                ".wcpa_has_label_related textarea",
            ].join(','), $form_outer).on('keyup change', function () {
                var $_form_outer = $(this).parents('.wcpa_form_outer');
                var related = $(this).parents('.wcpa_has_label_related').data('label_depends');
                if (related != null) {
                    related.forEach(function (el) {
                        exc_Label(el, $_form_outer);
                    });
                }

            });

            $('.wcpa_has_label_related', $form_outer).each(function () {
                var related = $(this).data('label_depends');
                if (related != null) {
                    related.forEach(function (el) {
                        exc_Label(el, $form_outer);
                    });
                }

            })
            $(".wcpa_has_label_formula", $form_outer).removeClass('wcpa_hide')
            $form_outer.data('wcpa', {});
            iterate($form_outer);
            var attrrelated = $form_outer.data('attrrelated');
            if (attrrelated != null) {
                attrrelated.forEach(function (el) {
                    exc_relations(el, $form_outer);
                });
            }
            if ($(".variations_form .variations").length) {
                setTimeout(function () {
                    $(".variations_form  .variations select").trigger("change");
                }, 0)
            }
            wcpa_may_update_quantity($form_outer);
        });


    }
    $(document).ready(function () {
        $.wcpaInit();
    });
    $.wcpaIterate = function () {
        $(".wcpa_form_outer").each(function () {
            iterate($(this));
        });

    }
})(jQuery);

//Trigger events, for quick view plugins
if (wcpa_global_vars.wcpa_init_triggers.length) {
    jQuery(document).on(wcpa_global_vars.wcpa_init_triggers.join(" "), function () {
        jQuery.wcpaInit();
    });
}
